package tamagotchi;

public class Tamagotchi {
	protected String name;
	protected int calories;
	protected boolean isAlive;
	
	private static int initCalories = 1000;
	protected static int caloriesPerActivity = 200;
	
	public Tamagotchi(String name){
		this.name = name;
		this.calories = initCalories;
		this.isAlive = true;		
	}
	
	public void eat(Food food){
		assert this.isAlive : " I musn't be a zombie for this";
	
		System.out.println(name + " has been fed with " + food.getName() + "\n");
		this.calories += food.getCalories(); 
	}
		
	public void play(){
		assert this.isAlive : " I musn't be a zombie for this";
		
		System.out.println(name + " is playing\n");
		
		consumeCalories();
	}
	
	public void viewStatistics(){
		if(isAlive) {
			System.out.println("The tamagotchi " + name + " has:");
			System.out.println("  calories:" + calories + " left");
		} else {
			System.out.println("The poor " + name + " passed away for a better life\n");
		}
	}
	
	public void die(){
		this.viewStatistics();
		
		if(calories > 0){
			System.out.println(name + ": Hey! i want to live, don't kill me!\n");
			consumeCalories();
		} else {
			System.out.println("\nIt's my fate hour, you didn't feed me");
			System.out.println(name + " is resting in pieces\n");
			
			this.isAlive = !isAlive;
		}
	}
	
	protected void consumeCalories(){
		this.calories -= caloriesPerActivity;
	}
}